#ifndef CONFIG_H
#define CONFIG_H
 

typedef float real_t;
typedef unsigned char uchar;

//static real_t avrage_dencity = 19.0f;
static real_t avrage_dencity = 1.0f;
//static real_t init_rho = 1.0f/19.0f;
static real_t init_rho = 0.0f;


//LBM Constants
static int iterMax = 5000;
//static int iterMax = 9739 -1;
static int iterSave = 100;


static double convergenceCriteria = 2.5e-3;
//static double convergenceCriteria = 2.5e-4;
//static double convergenceCriteria = 2.5e-5;
//static double convergenceCriteria = 2.5e-9;

// Force to add to each lattice location
//static real_t force = 0.000075f;
//static real_t force = 0.00001f;
static real_t force = 1e-5;
//static real_t force = 0.0000f;

// A darcy, the unit of measurements for permeability for fluids in porous media, 1 mD is equal to 0.001 darcy
static real_t toMilliDarcy = 1.013250e3;

static double toSec = 1.0e6;




#define mode_mpi 1
#define mode_thread 2
#define mode_hybrid 3

#ifndef MODE
#define MODE 2
#endif




#ifndef DATASET
#define DATASET 7
#endif

#if DATASET == 1
#define tau 0.63
//#define tau (1.f/1.5f)
#define DATA_FILE "symetric.dat"
#define LOCAL_SIZE_X 45
#define EXTRA_LAYERS 10
#define PERIODIC_Z 0

#endif

#if DATASET == 2 

#define tau (1.f/1.5f)
#define DATA_FILE "grid50.dat"
#define LOCAL_SIZE_X 30
#define EXTRA_LAYERS 10
#define PERIODIC_Z 0
#endif

#if DATASET == 3
//#define tau 0.63
#define tau (1.f/1.5f)
#define DATA_FILE "squareTube.dat"
#define LOCAL_SIZE_X 2
#define LOCAL_SIZE_Y 6
#define LOCAL_SIZE_Z 1
#define EXTRA_LAYERS 10
#define PERIODIC_Z 0

#endif
#if DATASET == 4
#define tau 0.63
#define LOCAL_SIZE_X 16
#define DATA_FILE "Validate"
#define PERIODIC_Z 1
#endif

#if DATASET == 5
#define tau (1.f/1.5f)
//#define tau 0.63
#define DATA_FILE "fontainebleau.dat"
#define LOCAL_SIZE_X 31
#define EXTRA_LAYERS 10
#define PERIODIC_Z 0

#endif

#if DATASET == 6
//#define tau 0.63
#define tau (1.f/1.5f)
#define DATA_FILE "grid500.dat"
#define LOCAL_SIZE_X 51
#define LOCAL_SIZE_Y 1
#define EXTRA_LAYERS 10
#define PERIODIC_Z 0
#endif

#if DATASET == 7
//#define tau 0.63
#define tau (1.f/1.5f)
#define DATA_FILE "grid800.dat"
#define LOCAL_SIZE_X 81
#define EXTRA_LAYERS 10
#define PERIODIC_Z 0
#endif

#if DATASET == 8
//#define tau 0.63
#define tau (1.f/1.5f)
#define DATA_FILE "grid1000.dat"
#define LOCAL_SIZE_X 101
#define EXTRA_LAYERS 10
#define PERIODIC_Z 0
#endif


//Used to run the Benchmarking with diffrent size of the lattice
#ifndef tau
#define tau 0.63
#endif
#ifndef DATA_FILE
#define DATA_FILE "MLUPS Benchmarking"
#endif

#ifndef PERIODIC_Z
#define PERIODIC_Z 0
#endif

#ifndef EXTRA_LAYERS
#define EXTRA_LAYERS 0
#endif

#ifndef LOCAL_SIZE_X
#define LOCAL_SIZE_X 16
#endif

#ifndef LOCAL_SIZE_Y
#define LOCAL_SIZE_Y 1
#endif

#ifndef LOCAL_SIZE_Z
#define LOCAL_SIZE_Z 1
#endif


#define N_VEC 19
#define MAX_LOCAL_SIZE 64
#define DEBUG 1


#define GHOST_LAYERS 1


#if MODE == mode_mpi
#define N_THREADS_PER_NODE 1
#define N_MPI_PRO_PER_NODE 2
#endif

#if MODE == mode_thread
//#define N_THREADS_PER_NODE 1
#define N_MPI_PRO_PER_NODE 0
#endif

#if MODE == mode_hybrid
#define N_THREADS_PER_NODE 2
#define N_MPI_PRO_PER_NODE 1
#endif





#ifdef WIN32
#define KERNEL_PATH "..//..//kernels.cl"
#define LOGFOLDER "logs\\"
#define PAUSE system("pause");
#define RUN_MPI 1
#else
#define KERNEL_PATH "kernels.cl"
#define LOGFOLDER "logs/"
#define PAUSE exit(-1);
//#define RUN_MPI 1
#endif


		

#endif		
