
#include "OpenCl_utils.h"



//Variables:
Program program;
Context context;


//Kernels
/*
cl::Kernel colide_and_swap;
cl::Kernel stream_and_swap;
cl::Kernel avrage_velocity;
*/

void setupOpenCL(CommandQueue *queues, int ant_device, int startpos)
{

  try {
    // Get available platforms
    vector<Platform> platforms;
    Platform::get(&platforms);

    // Select the default platform and create a context using this platform and the GPU
    cl_context_properties cps[3] = {
      CL_CONTEXT_PLATFORM,
      (cl_context_properties)(platforms[0])(),
      0
    };
    /*
    cl_context_properties cps[7] = {
    #ifdef WIN32
    CL_GL_CONTEXT_KHR, (cl_context_properties)wglGetCurrentContext(),
    CL_WGL_HDC_KHR, (cl_context_properties)wglGetCurrentDC(),
    #else
    CL_GL_CONTEXT_KHR, (cl_context_properties)glXGetCurrentContext(),
    CL_GLX_DISPLAY_KHR, (cl_context_properties)glXGetCurrentDisplay(),
    #endif
    CL_CONTEXT_PLATFORM, (cl_context_properties)(platforms[0])(),
    0
    };
    */
    
    vector<Device> devices2;
    Device dev;
    platforms[0].getDevices(CL_DEVICE_TYPE_GPU, &devices2);
    //std::cout << devices2.size() << "---" << std::endl;
    vector<Device> devices;
    
    //check that we have enought devices to forfill the requirement
    if(devices2.size() < ant_device + startpos){
      std::cout << "WARNING: " << std::endl;
      std::cout << "Not enought devices required " << ant_device;
      std::cout << " have " << devices2.size() << " avalible" << std::endl;
    }

    //select the "ant_device" first devices, or multiple times the laste   
    for(int i = 0; i < ant_device; i++){
      if (i < devices2.size()){

        //silly hack to prevent choosing teh GTX460 card
        if (!devices2[i+startpos].getInfo<CL_DEVICE_NAME>().compare("GeForce GTX 460")){ // compare 0 when equal 1 when not
          i++;  
        }
/*
        if (startpos == -1){
          if (i == 1){
            devices.push_back(devices2[i+1]); 
          }else{
            devices.push_back(devices2[i]);
          }
        }else{
        //devices.push_back(devices2[i+startpos*2]);
        devices.push_back(devices2[i+startpos]);
        }
        */
         devices.push_back(devices2[i+startpos]);
        //std::cout << "Device "<< devices2[i+startpos].getInfo<CL_DEVICE_NAME>() <<std::endl;
      }
    }
    
    //create the contex for all the devices
    context = Context(devices, cps);
    
    //creat ques for each device
    for(int i = 0; i < ant_device; i++){
      // Create a command queue for the device
      dev = devices[i < devices.size() ? i : devices.size() - 1 ];
      queues[i] = CommandQueue(context, dev,CL_QUEUE_PROFILING_ENABLE);

      std::cout << "Using Device " << dev.getInfo<CL_DEVICE_NAME>() << std::endl;
      std::cout << "Global mem " << dev.getInfo<CL_DEVICE_GLOBAL_MEM_SIZE>() << std::endl;
      std::cout << "Shared mem " << dev.getInfo<CL_DEVICE_LOCAL_MEM_SIZE>() << std::endl;
      //std::cout << " (" << dev.object_ << ")" << std::endl;
      
         
      //int devid = 0;
      //devid  = queues[i].getInfo<CL_QUEUE_DEVICE>();
      
      //printf("Rank %d taks device %s\n",startpos,strDev.c_str());
    }

    // Read source file
    std::ifstream sourceFile(KERNEL_PATH);
    if(sourceFile.fail()) {
      std::cout << "Failed to open OpenCL source file " << KERNEL_PATH << std::endl;
      system("pause");
      exit(-1);
    }
    std::string sourceCode(
      std::istreambuf_iterator<char>(sourceFile),
      (std::istreambuf_iterator<char>()));
    Program::Sources source(1, std::make_pair(sourceCode.c_str(), sourceCode.length()+1));

    // Make program of the source code in the context
    program = Program(context, source);

    // Build program for these specific devices
    try{
      program.build(devices);

      //program.getInfo<CL_PROGRAM_BINARIES>
      
    } catch(Error error) {
      // if(error.err() == CL_BUILD_PROGRAM_FAILURE) {
      std::cout << "Build error" << std::endl;
      //std::cout << program.getInfo<CL_PROGRAM_BINARIES>() << std::endl;
      std::cout << "Build log:\t" << program.getBuildInfo<CL_PROGRAM_BUILD_LOG>(devices[0]) << std::endl;
      // }
      throw error;
    }



    //Kernels
    /*
    colide_and_swap  =  Kernel(program,"collide_and_swap");
    stream_and_swap  =  Kernel(program,"stream_and_swap");
    avrage_velocity  =  Kernel(program,"avrage_velocity_ux");
    */

  } catch(Error error) {
    std::cout << "setup OpenCl" << std::endl;
    std::cout << error.what() << "(" << error.err() << ")" << std::endl;
    std::cout << getCLErrorString(error.err()) << std::endl;
    system("pause");
    exit(-1);
  }
}


void allocateMemoryGPU(int size_x, int size_y, int size_z, int totalVoxels, int *solid_h, Buffer *d_f, Buffer &d_avrage_velocity, Image3D &d_solids, double &time)
{

  long t1;
  long t2;
/*
  int next_powerof2 = 1;
  while (next_powerof2 < totalVoxels){
    next_powerof2 = next_powerof2 << 1;
  }
*/
  //Start timer
  getTimeInMs(t1);

  real_t *dummy = new real_t[totalVoxels];
/*
  real_t *dummy2 = new real_t[next_powerof2];
  for (int i = 0; i < next_powerof2; i++){
    dummy2[i] = 0.0f;
  }
*/
  for (int i = 0; i < totalVoxels; i++){
    dummy[i] = init_rho;
  }
  try{
    //f0 - f18
    for(int i = 0 ; i < N_VEC; i++){
      d_f[i] = createBuffer(totalVoxels *sizeof(real_t), CL_MEM_READ_WRITE,dummy);
      //d_f[i] = createBuffer(totalVoxels *sizeof(real_t), CL_MEM_READ_WRITE,NULL);
    }

      for (int i = 0; i < totalVoxels; i++){
       dummy[i] = 0.0f;
      }

    //avrage velocity
    d_avrage_velocity =  createBuffer(totalVoxels *sizeof(real_t), CL_MEM_WRITE_ONLY,dummy);
    //d_avrage_velocity =  createBuffer(totalVoxels *sizeof(real_t), CL_MEM_WRITE_ONLY,NULL);



    // allocate and copy over the solids
    d_solids = Image3D(context, CL_MEM_READ_ONLY | CL_MEM_COPY_HOST_PTR, 
    ImageFormat(CL_R, CL_SIGNED_INT32), 
    size_x,size_y,size_z, 
    0,0,
    solid_h);
    
    delete[] dummy;
    //delete[] dummy2;
  } catch(Error error) {
   std::cout << "allocateMemoryGPU" << std::endl;
   std::cout << error.what() << "(" << error.err() << ")" << std::endl;
   std::cout << getCLErrorString(error.err()) << std::endl;
   system("pause");
   exit(-1);
  }
  
  //stop timer
  getTimeInMs(t2);
  time = (double (t2 - t1) / toSec);
}


void freeMemoryGPU(){
  //try{
  //  //f0 - f18
  //  for(int i = 0 ; i < N_VEC; i++){
  //    d_f[i].release();
  //  }

  //  //avrage velocity
  //  d_avrage_velocity.release();

  //  // allocate and copy over the solids
  //  d_solids.release();



  //  //kernels
  //  stream_and_swap.release();
  //  colide_and_swap.release();
  //} catch(Error error) {
  //  std::cout << "allocateMemoryGPU" << std::endl;
  //  std::cout << error.what() << "(" << error.err() << ")" << std::endl;
  //  std::cout << getCLErrorString(error.err()) << std::endl;
  //  system("pause");
  //}
}


void streamAndSwapGPU(CommandQueue queue, Kernel stream_and_swap, int size_x, int size_y, int size_z, Event *event, Buffer *d_f, Image3D &d_solids, Buffer &max_change){
  try{

    NDRange global (size_x,size_y,size_z);
    NDRange local  = NullRange;

/*
    Buffer out = createBuffer(size_x * size_y * sizeof(uchar),CL_MEM_WRITE_ONLY);
    uchar *res = new uchar[size_x * size_y];
*/

    //set parameters
    stream_and_swap.setArg(0,d_solids);
    stream_and_swap.setArg(1,d_f[0]);
    stream_and_swap.setArg(2,d_f[1]);
    stream_and_swap.setArg(3,d_f[2]);
    stream_and_swap.setArg(4,d_f[3]);
    stream_and_swap.setArg(5,d_f[4]);
    stream_and_swap.setArg(6,d_f[5]);
    stream_and_swap.setArg(7,d_f[6]);
    stream_and_swap.setArg(8,d_f[7]);
    stream_and_swap.setArg(9,d_f[8]);
    stream_and_swap.setArg(10,d_f[9]);
    stream_and_swap.setArg(11,d_f[10]);
    stream_and_swap.setArg(12,d_f[11]);
    stream_and_swap.setArg(13,d_f[12]);
    stream_and_swap.setArg(14,d_f[13]);
    stream_and_swap.setArg(15,d_f[14]);
    stream_and_swap.setArg(16,d_f[15]);
    stream_and_swap.setArg(17,d_f[16]);
    stream_and_swap.setArg(18,d_f[17]);
    stream_and_swap.setArg(19,d_f[18]);
    stream_and_swap.setArg(20,max_change);

   queue.enqueueNDRangeKernel(stream_and_swap,NullRange,global,local,NULL,event);
   
/*
    queue.finish();

    int ant = 120704;
    real_t *res  = new real_t[ant];

    for (int i = 0; i < 19; i++){
      for(int j = 0; j < ant ; j++ ){
        res[j] = 10.0;
      }
      queue.enqueueReadBuffer(d_f[i],CL_TRUE,0,ant*sizeof(real_t),res);
      queue.finish();
      printf("force %d\n",i);
      for (int k = 0; k < ant; k++){
        printf("%d ",k);
        printf("%e",res[k]);
        printf("\n");
      }

    }
*/


  } catch(Error error) {
   std::cout << "Stream and swap" << std::endl;
   std::cout << error.what() << "(" << error.err() << ")" << std::endl;
   std::cout << getCLErrorString(error.err()) << std::endl;
   system("pause");
   exit(-1);
  }
}
void collideAndSwapGPU(CommandQueue queue, Kernel colide_and_swap, 
					   int size_x, int size_y, int size_z, int offset_x, int offset_y, int offset_z, 
					   real_t omega, real_t force, Event *event, Buffer *d_f, Image3D &d_solids, int index){
  try{

    NDRange global (size_x,size_y,size_z);
    NDRange local (LOCAL_SIZE_X,LOCAL_SIZE_Y,LOCAL_SIZE_Z);
	//NDRange global_offsett (offset_x,offset_y,offset_z);
	//NDRange global_offsett (0,0,0);
    
    //LocalSpaceArg sharedMemoryCollision = cl::__local(1*N_VEC * sizeof(real_t));
	static LocalSpaceArg sharedMemoryCollision = cl::__local(LOCAL_SIZE_X*LOCAL_SIZE_Y*LOCAL_SIZE_Z*N_VEC * sizeof(real_t));


/*
    long t1;
    long t2;
    //Start timer
    getTimeInMs(t1);
*/


    //set parameters
    colide_and_swap.setArg(0,d_solids);
    colide_and_swap.setArg(1,d_f[0]);
    colide_and_swap.setArg(2,d_f[1]);
    colide_and_swap.setArg(3,d_f[2]);
    colide_and_swap.setArg(4,d_f[3]);
    colide_and_swap.setArg(5,d_f[4]);
    colide_and_swap.setArg(6,d_f[5]);
    colide_and_swap.setArg(7,d_f[6]);
    colide_and_swap.setArg(8,d_f[7]);
    colide_and_swap.setArg(9,d_f[8]);
    colide_and_swap.setArg(10,d_f[9]);
    colide_and_swap.setArg(11,d_f[10]);
    colide_and_swap.setArg(12,d_f[11]);
    colide_and_swap.setArg(13,d_f[12]);
    colide_and_swap.setArg(14,d_f[13]);
    colide_and_swap.setArg(15,d_f[14]);
    colide_and_swap.setArg(16,d_f[15]);
    colide_and_swap.setArg(17,d_f[16]);
    colide_and_swap.setArg(18,d_f[17]);
    colide_and_swap.setArg(19,d_f[18]);
    colide_and_swap.setArg(20,sharedMemoryCollision);
    colide_and_swap.setArg(21,omega);
    colide_and_swap.setArg(22,force);
    colide_and_swap.setArg(23,avrage_dencity);
    colide_and_swap.setArg(24,N_VEC);

	colide_and_swap.setArg(25,offset_x);
	colide_and_swap.setArg(26,offset_y);
	colide_and_swap.setArg(27,offset_z);

    //colide_and_swap.setArg(25,index);

	queue.enqueueNDRangeKernel(colide_and_swap,NullRange,global,local,NULL,event);
/*
    queue.finish();

    int ant = 120704;
    real_t *res  = new real_t[ant];

    for (int i = 0; i < 19; i++){
      for(int j = 0; j < ant ; j++ ){
        res[j] = 10.0;
      }
      queue.enqueueReadBuffer(d_f[i],CL_TRUE,0,ant*sizeof(real_t),res);
      queue.finish();
      printf("force %d\n",i);
      for (int k = 0; k < ant; k++){
        printf("%d ",k);
        printf("%e",res[k]);
        printf("\n");
      }

    }
*/
    /*
    //stop timer
    getTimeInMs(t2);
    time = (double (t2 - t1) / toSec);
*/
  } catch(Error error) {
   std::cout << "Collide and swap" << std::endl;
   std::cout << error.what() << "(" << error.err() << ")" << std::endl;
   std::cout << getCLErrorString(error.err()) << std::endl;
   system("pause");
   exit(-1);
  }
}

void getAverageVelocityXGPU(CommandQueue queue, Kernel avrage_velocity, Kernel reduction,  Buffer *d_f, Buffer &d_avrage_velocity, Image3D &d_solids,
                              int total_voxels, int size_x, int size_y, int size_z, int extra, vector<Event> &events, int ghost_layers_north, int ghost_layers_south, real_t *avg_vel)
{

  //long t1;
  //long t2;

  //the number of elements tu sum rounded up to the neqres MAX_LOCAL_SIZE
  //int blockSize = ceilf((double) (total_voxels) / (double) MAX_LOCAL_SIZE);



  static int threads_6 = 128;     
  //int groups_6 = 64;

       
  //    int antWorkGroups =  MAX_LOCAL_SIZE; 
  //Buffer d_out = createBuffer(groups_6 * sizeof(real_t),CL_MEM_READ_WRITE);

  try{
    Buffer d_result = createBuffer(1 * sizeof(real_t),CL_MEM_READ_WRITE); 

    NDRange global (size_x,size_y,size_z);
    NDRange local (LOCAL_SIZE_X,LOCAL_SIZE_Y,LOCAL_SIZE_Z);

    static LocalSpaceArg sharedMemoryAvgVel = cl::__local(LOCAL_SIZE_X*LOCAL_SIZE_Y*LOCAL_SIZE_Z*N_VEC * sizeof(real_t));
    static LocalSpaceArg sharedMemoryReduction = cl::__local( threads_6 * sizeof(real_t));



    //Start timer
    //getTimeInMs(t1);

    //set parameters
    avrage_velocity.setArg(0,d_solids);
    avrage_velocity.setArg(1,d_f[0]);
    avrage_velocity.setArg(2,d_f[1]);
    avrage_velocity.setArg(3,d_f[2]);
    avrage_velocity.setArg(4,d_f[3]);
    avrage_velocity.setArg(5,d_f[4]);
    avrage_velocity.setArg(6,d_f[5]);
    avrage_velocity.setArg(7,d_f[6]);
    avrage_velocity.setArg(8,d_f[7]);
    avrage_velocity.setArg(9,d_f[8]);
    avrage_velocity.setArg(10,d_f[9]);
    avrage_velocity.setArg(11,d_f[10]);
    avrage_velocity.setArg(12,d_f[11]);
    avrage_velocity.setArg(13,d_f[12]);
    avrage_velocity.setArg(14,d_f[13]);
    avrage_velocity.setArg(15,d_f[14]);
    avrage_velocity.setArg(16,d_f[15]);
    avrage_velocity.setArg(17,d_f[16]);
    avrage_velocity.setArg(18,d_f[17]);
    avrage_velocity.setArg(19,d_f[18]);
    avrage_velocity.setArg(20,sharedMemoryAvgVel);
    avrage_velocity.setArg(21,d_avrage_velocity);
    avrage_velocity.setArg(22,avrage_dencity);
    avrage_velocity.setArg(23,N_VEC);
    avrage_velocity.setArg(24,ghost_layers_north);
    avrage_velocity.setArg(25,ghost_layers_south);
    avrage_velocity.setArg(26,(extra/2));

    queue.enqueueNDRangeKernel(avrage_velocity,NullRange,global,local,NULL,&events[0]);
    //queue.finish();


/*
    queue.finish();

    int ant = total_voxels;
    real_t *res  = new real_t[ant];

    for(int j = 0; j < ant ; j++ ){
      res[j] = 10.0;
    }

    queue.enqueueReadBuffer(d_avrage_velocity,CL_TRUE,0,ant*sizeof(real_t),res);
    queue.finish();
*/



    //******************************
    //WORKING
    //******************************

    //Reduce the a singel velocity
    NDRange global_reduction (threads_6); //length);
    NDRange local_reduction (threads_6);

    reduction.setArg(0,d_avrage_velocity);
    reduction.setArg(1,sharedMemoryReduction);
    reduction.setArg(2,total_voxels);
    reduction.setArg(3,d_result);


    queue.enqueueNDRangeKernel(reduction,NullRange,global_reduction,local_reduction);
    readBuffer(queue,d_result,avg_vel,1*sizeof(real_t),&events[1]); 
    //queue.finish();

/*
    double sum[2] = {0,0};
    for ( int i=0; i<total_voxels; i++ )
      sum[i&1]+=(double)res[i];
    *avg_vel = (float)(sum[0]+sum[1]);

*/
/*
    double u_sum = 0.;
    for (int i = 0; i < total_voxels; i++){
      u_sum += (double) res[i];
    }

    printf("result CPU = %e\n", u_sum);
    printf("result GPU = %e\n", *avg_vel);
    printf("Diff\t %e \n",u_sum - *avg_vel);

    *avg_vel = (float) u_sum;
*/
  } catch(Error error) {
    std::cout << "Avrage velocity" << std::endl;
    std::cout << error.what() << "(" << error.err() << ")" << std::endl;
    std::cout << getCLErrorString(error.err()) << std::endl;
    system("pause");
    exit(-1);
  }

  //double u_sum = u_new[0];
  

  
  
  //for(int z=0; z<size_z; z++)
  //{ 
  //  for(int y=0; y<size_y; y++)
  //  {
  //    for(int x=(extra/2); x<size_x-(extra/2); x++)
  //    {
  //      int i = x + y*size_x + z*size_x*size_y;
  //      u_sum += (double) u_new[i];
  //    }
  //  }
  //}
  /*
  for(int z=0; z<size_z; z++)
  { 
  printf("layer %d\n",z);
  for(int y=0; y<size_y; y++)
  {
  for(int x=(extra/2); x<size_x-(extra/2); x++)
  {
  int i = x + y*size_x + z*size_x*size_y;
  printf("%e ", u_new[i]);
  }
  printf("\n");
  }
  printf("\n");
  }
  */

  /*
  //stop timer
  getTimeInMs(t2);
  time = (double (t2 - t1) / toSec);
  */
}





void readBuffer(CommandQueue queue, Buffer src, void *dst, int length,Event *event){
  readBuffer(queue,src,0,dst,length,event);
}


void readBuffer(CommandQueue queue, Buffer src, int offset, void *dst, int length,Event *event){
  queue.enqueueReadBuffer(src, CL_FALSE, offset, length, dst,NULL,event);
}

void writeBuffer(CommandQueue queue, Buffer dst, void *src, int length,Event *event){
  writeBuffer(queue,dst,0,src,length,event);
}
void writeBuffer(CommandQueue queue, Buffer dst,int offset, void *src, int length,Event *event){
  queue.enqueueWriteBuffer(dst, CL_FALSE, offset, length, src,NULL,event);
}
Buffer createBuffer( int size, cl_mem_flags flags){
  return createBuffer(size, flags, 0);
}

Buffer createBuffer( int size, cl_mem_flags flags, void *data){
  if (data != NULL){
    flags = flags | CL_MEM_COPY_HOST_PTR;
  }
  
  Buffer buf = Buffer(context,flags,size,data);
  return buf;
}
Kernel createKernel(const char* filename){
  Kernel kernel(program, filename);
  return kernel;
}

double executionTime(Event &event)
{
  cl_ulong start, end;
  try{
    
    end = event.getProfilingInfo<CL_PROFILING_COMMAND_END>();
    start = event.getProfilingInfo<CL_PROFILING_COMMAND_START>();
    
    //start = event.getProfilingInfo<CL_PROFILING_COMMAND_SUBMIT>();
    //start = event.getProfilingInfo<CL_PROFILING_COMMAND_QUEUED>();

  
  } catch(Error error) {
    std::cout << "executionTime" << std::endl;
    std::cout << error.what() << "(" << error.err() << ")" << std::endl;
    std::cout << getCLErrorString(error.err()) << std::endl;
    PAUSE
    exit(-1);
  }
return 1.0e-9 * (double) (end - start);
//return  (double) (end - start);

}





char *getCLErrorString(cl_int err) {
  switch (err) {
        case CL_SUCCESS:                          return strdup("Success!");
        case CL_DEVICE_NOT_FOUND:                 return strdup("Device not found.");
        case CL_DEVICE_NOT_AVAILABLE:             return strdup("Device not available");
        case CL_COMPILER_NOT_AVAILABLE:           return strdup("Compiler not available");
        case CL_MEM_OBJECT_ALLOCATION_FAILURE:    return strdup("Memory object allocation failure");
        case CL_OUT_OF_RESOURCES:                 return strdup("Out of resources");
        case CL_OUT_OF_HOST_MEMORY:               return strdup("Out of host memory");
        case CL_PROFILING_INFO_NOT_AVAILABLE:     return strdup("Profiling information not available");
        case CL_MEM_COPY_OVERLAP:                 return strdup("Memory copy overlap");
        case CL_IMAGE_FORMAT_MISMATCH:            return strdup("Image format mismatch");
        case CL_IMAGE_FORMAT_NOT_SUPPORTED:       return strdup("Image format not supported");
        case CL_BUILD_PROGRAM_FAILURE:            return strdup("Program build failure");
        case CL_MAP_FAILURE:                      return strdup("Map failure");
        case CL_INVALID_VALUE:                    return strdup("Invalid value");
        case CL_INVALID_DEVICE_TYPE:              return strdup("Invalid device type");
        case CL_INVALID_PLATFORM:                 return strdup("Invalid platform");
        case CL_INVALID_DEVICE:                   return strdup("Invalid device");
        case CL_INVALID_CONTEXT:                  return strdup("Invalid context");
        case CL_INVALID_QUEUE_PROPERTIES:         return strdup("Invalid queue properties");
        case CL_INVALID_COMMAND_QUEUE:            return strdup("Invalid command queue");
        case CL_INVALID_HOST_PTR:                 return strdup("Invalid host pointer");
        case CL_INVALID_MEM_OBJECT:               return strdup("Invalid memory object");
        case CL_INVALID_IMAGE_FORMAT_DESCRIPTOR:  return strdup("Invalid image format descriptor");
        case CL_INVALID_IMAGE_SIZE:               return strdup("Invalid image size");
        case CL_INVALID_SAMPLER:                  return strdup("Invalid sampler");
        case CL_INVALID_BINARY:                   return strdup("Invalid binary");
        case CL_INVALID_BUILD_OPTIONS:            return strdup("Invalid build options");
        case CL_INVALID_PROGRAM:                  return strdup("Invalid program");
        case CL_INVALID_PROGRAM_EXECUTABLE:       return strdup("Invalid program executable");
        case CL_INVALID_KERNEL_NAME:              return strdup("Invalid kernel name");
        case CL_INVALID_KERNEL_DEFINITION:        return strdup("Invalid kernel definition");
        case CL_INVALID_KERNEL:                   return strdup("Invalid kernel");
        case CL_INVALID_ARG_INDEX:                return strdup("Invalid argument index");
        case CL_INVALID_ARG_VALUE:                return strdup("Invalid argument value");
        case CL_INVALID_ARG_SIZE:                 return strdup("Invalid argument size");
        case CL_INVALID_KERNEL_ARGS:              return strdup("Invalid kernel arguments");
        case CL_INVALID_WORK_DIMENSION:           return strdup("Invalid work dimension");
        case CL_INVALID_WORK_GROUP_SIZE:          return strdup("Invalid work group size");
        case CL_INVALID_WORK_ITEM_SIZE:           return strdup("Invalid work item size");
        case CL_INVALID_GLOBAL_OFFSET:            return strdup("Invalid global offset");
        case CL_INVALID_EVENT_WAIT_LIST:          return strdup("Invalid event wait list");
        case CL_INVALID_EVENT:                    return strdup("Invalid event");
        case CL_INVALID_OPERATION:                return strdup("Invalid operation");
        case CL_INVALID_GL_OBJECT:                return strdup("Invalid OpenGL object");
        case CL_INVALID_BUFFER_SIZE:              return strdup("Invalid buffer size");
        case CL_INVALID_MIP_LEVEL:                return strdup("Invalid mip-map level");
        default:                                  return strdup("Unknown");
  }
}
