#ifndef SIMULATION_MPI_H
#define SIMULATION_MPI_H

//OpenCL
#include "CL/cl.h"

// The lattice Boltzmann method
#include "LBM_3D.h"
#include "Timer.h"

#include "Simulation_utils.h"

//include mpi.h
#include <mpi.h>

/* Enable the CPU_SET... macros in sched.h */
#ifndef __USE_GNU
#define __USE_GNU
#endif
#ifndef _GNU_SOURCE
#define _GNU_SOURCE
#endif
#ifdef UNIX
#include <sched.h>
#include <unistd.h>
#endif



void runSimulationMPI(int mpi_rank, int mpi_size, int num_threads);
void printIndevidualTimingsMPI(char *stream,int num_threads);
void copyAvgVelToCPU_MPI(real_t *u_new, int mpi_size, int ant_threads);
void calculateAvrageVelocityMPI( real_t *avg_velocities, int mpi_rank, int ant_threads);

#endif