#ifndef SIMULATION_UTILS_H
#define SIMULATION_UTILS_H

//OpenCL
//#include "CL/cl.h"

//The lattice Boltzmann method
#include "LBM_3D.h"

//#include "Timer.h"

#include "Types.h"



void loadData(int extra);
void extendData(int layers_north, int layers_south);


int getSizeX();
int getSizeY();
int getSizeZ();
uchar getSolid(int x,int y,int z);


real_t getPorosity();
double getConvergence();
double getPermeability(double averageVelocity, bool doDeltaF);


void waitToFinish(LBM_3D ** lbm, int ant, int place);

void printState();
void printFinaleState(FILE *stream);

//Used for validation on the implementations
void createPoiseuilleFlow2D(int L);
void createPoiseuilleFlow1D(int x, int y, int z);
void writePoiseuilleFlow2DToFile(FILE *pFile, int *h_solids, real_t *u_new);
#endif