#include "Timer.h"

void getTimeInMs(long &timer){
  long elapsedTime;

#ifdef WIN32
 /* Windows copy from internet
  * http://www.songho.ca/misc/timer/timer.html
  */
  LARGE_INTEGER frequency;         // ticks per second
  LARGE_INTEGER t1;          // ticks


  // get ticks per second
  QueryPerformanceFrequency(&frequency);

  // start timer
  QueryPerformanceCounter(&t1);

  // compute and print the elapsed time in millisec
  elapsedTime = t1.QuadPart * 1000000 / frequency.QuadPart;
#else
  timeval t1;
  gettimeofday(&t1, NULL);

  //elapsedTime = (t1.tv_sec * 1000.0);      // sec to ms
  //elapsedTime += (t1.tv_usec / 1000.0);   // us to ms
  
  elapsedTime = (t1.tv_sec * 1.0e6);      // sec to ms
 elapsedTime += (t1.tv_usec);   // us to ms
  
#endif

  timer = elapsedTime;
}