#include "Timer_runner.h"




using namespace std;


void check_for_correctness(double * a, double *b, int ant);
double send_data_mpi(int ant_elements);
void reset_data (double *a, double *b, int ant);
void TestOpenCLBW(CommandQueue *queues, int ant_devices, int ant_element, 
                  double *time_startup, double *time_startup_cpu, double *time_startup_var, 
                  double *time_half, double *time_half_cpu, double *time_half_var,
                  double *time_full, double *time_full_cpu, double *time_full_var);


//double time_startup = 0.0;
//double time_half = 0.0;
//double time_full = 0.0;

double time_mpi_startup = 0.0;
double time_mpi_half = 0.0;
double time_mpi_full = 0.0;
int rank, size, other_rank;
double *a,*b;
int last;
MPI_Request request_recive,  request_send;
MPI_Status status;


double toMB = 1./(1024. * 1024.);

int ant_ittr = 1000;
int ant_pass = 4;
int ant_devices = 1;

double t0,t1;

int main(int argc, char** argv)
{
  //double time;
  long tot_time;
  long time;



  double *time_startup_cpu = new double[ant_pass * ant_devices];
  double *time_startup = new double[ant_pass * ant_devices];
  double *time_startup_var = new double[ant_pass * ant_devices];

  double *time_half = new double[ant_pass * ant_devices];
  double *time_half_cpu = new double[ant_pass * ant_devices];
  double *time_half_var = new double[ant_pass * ant_devices];
  
  double *time_full_cpu = new double[ant_pass * ant_devices];
  double *time_full = new double[ant_pass * ant_devices];
  double *time_full_var = new double[ant_pass * ant_devices];

  double *time_1_byte_cpu = new double[ant_pass * ant_devices];
  double *time_1_byte = new double[ant_pass * ant_devices];

  //int ant_element = 1240*19;
  //int ant_element = 100*100*100*19;
  //int ant_element = 15000;

#if MODE == mode_mpi  
  MPI_Init(&argc, &argv);
  MPI_Comm_size(MPI_COMM_WORLD, &size);
  MPI_Comm_rank(MPI_COMM_WORLD, &rank);
#endif

  if(rank == 0){

    /*
    * OpenCL timings
    *
    */
    printf("Timing OpenCL\n");
    
    getTimeInMs(time);
    tot_time = -time;
    

    //initilize openCL 
    CommandQueue *queues = new CommandQueue[ant_devices];
    setupOpenCL(queues,ant_devices,1);

     std::string dummy;
    std::string file_n_convergence;
    file_n_convergence = LOGFOLDER + dummy + "bandwidth.txt";

    FILE *p_bw;
    p_bw = fopen(file_n_convergence.c_str(),"w+");
    
    

    //int ant_element = 1000 ;// 1024*1024*10/4;
    int ant_element =  1024*1024*1/4;
    //int ant_element =  18000*19*4;
    for (int p = 0; p < ant_pass; p++){
      ant_element += 100; //1024*1024/8;

      //ant_element +=1024*1024*1/4;

      
      printf("\n\nPASS %d\n",p);
      TestOpenCLBW(queues, ant_devices, ant_element,
        &time_startup[p*ant_devices], &time_startup_cpu[p*ant_devices], &time_startup_var[p*ant_devices], 
        &time_half[p* ant_devices],&time_half_cpu[p* ant_devices], &time_half_var[p* ant_devices],
        &time_full[p * ant_devices],&time_full_cpu[p * ant_devices], &time_full_var[p * ant_devices]);

      printf("clEnqueueWriteBuffer startup: %e s \n",time_startup[p * ant_devices]);
      printf("sqr startup %e (%f %% )\n",(time_startup_var[p * ant_devices]), ((time_startup_var[p * ant_devices]/time_startup[p * ant_devices])*100.0));
      /*
      printf("clEnqueueWriteBuffer %f MB data: %e s ",ant_element * sizeof(float) / 2 * toMB,time_half[p * ant_devices]);
      printf("%f MB/s \n",ant_element * sizeof(float) / 2 * toMB/(time_half[p * ant_devices]));
      */
      printf("clEnqueueWriteBuffer %f MB data: %e s ",ant_element * sizeof(float) * toMB ,time_full[p * ant_devices]);
      printf("%f MB/s \n",ant_element * sizeof(float) * toMB / (time_full[p * ant_devices]));
      
      printf("sqr bw %e (%f %%)\n",(time_full_var[p * ant_devices]),(time_full_var[p * ant_devices]/time_full[p * ant_devices])*100.0);

      fprintf(p_bw, "%e ",ant_element * sizeof(float)*toMB);

      for(int d = 0; d < ant_devices; d++){
        time_1_byte[p * ant_devices +d] =  time_full[p * ant_devices +d] / (ant_element * sizeof(float)) ;
        //fprintf(p_bw, "%e ", (1.0 / time_1_byte[p * ant_devices +d]) *toMB); 
        //fprintf(p_bw, "%e ", (time_full[p * ant_devices +d])); 
        
        //fprintf(p_bw, "%e ", (time_full_var[p * ant_devices +d])); 

        //fprintf(p_bw, "%e ", (time_startup[p * ant_devices +d])); 
        //fprintf(p_bw, "%e ", (time_startup_cpu[p * ant_devices +d])); 

        fprintf(p_bw, "%e ", (time_full[p * ant_devices +d])); 
        fprintf(p_bw, "%e ", (time_full_cpu[p * ant_devices +d])); 

      }
      
      fprintf(p_bw, "\n");
      printf("clEnqueueWriteBuffer time for 1 Byte %e s \n", time_1_byte[p * ant_devices]);
    }

    fclose(p_bw);

    getTimeInMs(time);
    tot_time += time;

    printf("\n\nTOTAL TIME  %e s\n",((double) tot_time / 1.0e6));
    
  }
    

#if MODE == mode_mpi  
  /*
  * MPI timings
  *
  */
  int ant_element = 2;
  if(rank == 0){
    printf("Timing MPI\n");
  }


  if (size != 2){
    printf("Wrong number of nodes\n");
    exit (1);
  }

  other_rank = (rank + 1) % 2;



  a = (double *) malloc (ant_element * sizeof (double));
  b = (double *) malloc (ant_element * sizeof (double));


  reset_data(a,b,ant_element);

  // startup
  time = 0.0;
  last = 0;
  for (int i = 0 ; i < ant_ittr*100;i++)
  {
    reset_data(a,b,last);
    time += send_data_mpi(0);
  }
  time_mpi_startup  =   (time / ((double) ant_ittr*100.0)); //converte from seconds to ms


  // Send halve data
  time = 0.0;
  last = (ant_element/2) -1;
  for (int i = 0 ; i < ant_ittr;i++)
  {
    reset_data(a,b,last);
    time += send_data_mpi(ant_element/2);

  }
  time_mpi_half =   ((time / (double) ant_ittr)) - time_mpi_startup; //converte from seconds to ms

    // Send hole data 
  time = 0.0;
  last = ant_element -1;
  for (int i = 0 ; i < ant_ittr;i++)
  {
    reset_data(a,b,last);
    time += send_data_mpi(ant_element);

  }
  time_mpi_full =   ((time / (double) ant_ittr)) - time_mpi_startup; //converte from seconds to ms





  if(rank == 0){
    printf("\n\n");
    printf("MPI startup: %e s \n",time_mpi_startup);
    printf("\n");

    printf("Isend Irecv %f MB data: %e s \n",2 * ant_element * sizeof(float) / 2 * toMB,time_mpi_half);
    printf("Isend Irecv BW %f MB/s \n",((2 * ant_element * sizeof(float) / 2) * toMB)/(time_mpi_half));
    printf("\n");

    printf("Isend Irecv %f MB data: %e s \n",2 * ant_element * sizeof(float) * toMB ,time_mpi_full);
    printf("Isend Irecv BW %f MB/s \n",(2 * ant_element * sizeof(float) * toMB) / (time_mpi_full));

    printf("\n");
    printf("ISend Irecv time for 1 Byte %e s \n", time_mpi_full / (2.0 * ant_element * sizeof(float)) );
  }
  MPI_Finalize();
#endif

/*
  // initialize random seed: 
  srand((int) (time_startup * 1000000));


  int ant_values = 32*32*32;
  float *values = new float[ant_values];
  float *values2 = new float[ant_values];
  float sum_float = 0.0;
  float sum_float2 = 0.0;
  double sun_double = 0.0;
  double sun_double2 = 0.0;

  for(int i = 0; i < ant_values; i++){
    values[i] = ((float)(rand() % 1000)/1000000.0);
    values2[i] = ((float)(rand() % 1000)/1000000.0);
    printf("Value %i %e\n",i,values[i]);
  }


  for(int i = 0; i < ant_values; i++){
    sum_float += values[i];
    sum_float2 += values2[i];
    sun_double += (double) values[i];
    sun_double2 += (double) values2[i];
    
  }

  printf("\n");
  printf("\n");

  printf("Float\t sum 1 %e sum 2 %e diff %e\n",sum_float,sum_float2, (sum_float - sum_float2));
  printf("Double\t sum 1 %e sum 2 %e diff %e\n",sun_double, sun_double2, (sun_double - sun_double2));
  printf("Diff\t\t %e\n",((sum_float - sum_float2) - (sun_double - sun_double2)  ));
*/

  //cleaning up
  delete[] time_full;
  delete[] time_startup;
  delete[] time_half;

  delete[] time_full_var;
  delete[] time_startup_var;
  delete[] time_half_var;

  delete[] time_full_cpu;
  delete[] time_startup_cpu;
  delete[] time_half_cpu;

  free(a);
  free(b);


  return 0;

}




void check_for_correctness(double * a, double *b, int ant)
{
  bool error = false;
  if ((b[0] != 1.0 || b[last] != last + 1)) {
    printf("Rank %d ERROR - b[0] = %f b[%d] = %f\n", rank, b[0], last, b[last]);
    error = true;
  }
  for (int i = 1; i < last - 1; i++){
    if (b[i] != (double) i){
      printf("Rank %d ERROR - b[%d] = %f\n",rank, i, b[i]);
      error= true;
    }
  }

  if(error){
    exit (1);
  }

}

double send_data_mpi(int ant_elements)
{
  
  double _time;
#if MODE == mode_mpi  
    
  //MPI_Barrier(MPI_COMM_WORLD);

  MPI_Irecv(b, ant_elements, MPI_DOUBLE, other_rank, 0, MPI_COMM_WORLD, &request_recive);
  MPI_Barrier(MPI_COMM_WORLD);
  t0 = MPI_Wtime();

  if (rank == 0) {

    MPI_Issend(a, ant_elements, MPI_DOUBLE, other_rank, 0, MPI_COMM_WORLD,&request_send);
    MPI_Wait(&request_send, &status);
    
    MPI_Wait(&request_recive, &status);

  } else {

    MPI_Wait(&request_recive, &status);

    b[0] += 1.0;
    if (last != 0)
      b[last] += 1.0;

    MPI_Issend(b, ant_elements, MPI_DOUBLE, other_rank, 0, MPI_COMM_WORLD, &request_send);
    MPI_Wait(&request_send, &status);
  }

  t1 = MPI_Wtime();
  _time = (t1 - t0);
  MPI_Barrier(MPI_COMM_WORLD);

  if(ant_elements != 0){
    check_for_correctness(a,b,ant_elements);
  }

  
#endif
  return _time;
}

void reset_data (double *a, double *b, int ant)
{
  for (int i = 0; i < ant; i++) {
    a[i] = (double) i;
    b[i] = 0.0;
  }


}


void TestOpenCLBW(CommandQueue *queues, int ant_devices, int ant_element, 
                  double *time_startup, double *time_startup_cpu, double *time_startup_var, 
                  double *time_half, double *time_half_cpu, double *time_half_var,
                  double *time_full, double *time_full_cpu, double *time_full_var)
{
    double *time = new double[ant_devices];
    float *h_data = new float[ant_element];
   
    double *avrage_timing = new double [ant_devices];
    double *avrage_timing_cpu = new double [ant_devices];
    double *square_root = new double [ant_devices];

    //double indivudual_timing[ant_ittr][ant_devices];
    double **indivudual_timing = new double*[ant_ittr];
      for(int i=0; i<ant_ittr; ++i)
        indivudual_timing[i]=new double[ant_devices];

    Buffer d_data = createBuffer(ant_element * sizeof(float),CL_MEM_READ_WRITE,NULL);
    Event *events = new Event[ant_devices];

    long t1,t2;


    //double dumme[8] = {2.0,4.0,4.0,4.0,5.0,5.0,7.0,9.0};


    //compute startup time
    for(int d = 0; d < ant_devices; d++){
      time[d] = 0.0;
      time_startup[d] = 0.0;
      square_root[d] = 0.0;
      avrage_timing[d] = 0.0;
      avrage_timing_cpu[d] = 0.0;
    }

    //printf("Timing the startup time of clEnqueueWriteBuffer \n");
    for (int i = 0 ; i < ant_ittr;i++)
    {
      getTimeInMs(t1);
      
      for(int d = 0; d < ant_devices; d++){
        writeBuffer(queues[d],d_data,h_data,1,&events[d]); //Have to send 1 byte as 0 byte result i 0 ms time, most likly openCl does somting smart
      }


      for(int d = 0; d < ant_devices; d++){
        queues[d].finish();
      }
      getTimeInMs(t2);
      

      for(int d = 0; d < ant_devices; d++){
        indivudual_timing[i][d] = executionTime(events[d]);
        //indivudual_timing[i][d] =  5; //executionTime(events[d]);
        //indivudual_timing[i][d] =  dumme[i]; //executionTime(events[d]);
        
        avrage_timing[d] += indivudual_timing[i][d];
        avrage_timing_cpu[d] += ((double)(t2-t1) / 1.0e6);
        time[d] += indivudual_timing[i][d];

      }

    }

    for(int d = 0; d < ant_devices; d++){
      avrage_timing[d] /= (double)ant_ittr;
      avrage_timing_cpu[d] /= (double)ant_ittr;

    }
    for (int it = 0; it < ant_ittr; it ++){
      for(int d = 0; d < ant_devices; d++){
        double diff = fabs(indivudual_timing[it][d] - avrage_timing[d]);
        double ratio = (diff / avrage_timing[d]);
        if (ratio > 1.0){
          //printf("individual timing %d in startup, time %e mean %e ratio %e\n",it,indivudual_timing[it][d],avrage_timing[d],ratio);
        }
       square_root[d] += (pow(diff,2.0));
      }
    }
 
    for(int d = 0; d < ant_devices; d++){
      square_root[d] /= (double)ant_ittr;
      square_root[d] = sqrt(square_root[d]);
    }


     for(int d = 0; d < ant_devices; d++){
      time_startup[d] =  (time[d] / ((double) ant_ittr)); //converte from seconds to ms
      time_startup_cpu[d] = avrage_timing_cpu[d];
      time_startup_var[d] = square_root[d]; 
    }


/*
     //send have the datasize
     for(int d = 0; d < ant_devices; d++)
       time[d] = 0.0;

     //printf("Timing the transfer of %f MB data with clEnqueueWriteBuffer \n", ant_element * sizeof(float) / 2 * toMB);
     for (int i = 0 ; i < ant_ittr;i++)
     {
       for(int d = 0; d < ant_devices; d++){
         writeBuffer(queues[d],d_data,h_data,ant_element / 2 * sizeof(float),&events[d]); 
       }

       for(int d = 0; d < ant_devices; d++){
         queues[d].finish();
       }

       for(int d = 0; d < ant_devices; d++){
         time[d] += executionTime(events[d]);
       }

     }
     for(int d = 0; d < ant_devices; d++)
      time_half[d] =  (time[d] / ((double) ant_ittr)) - time_startup[d]; //converte from seconds to ms
*/
    
     
     
     // send full data size
     for(int d = 0; d < ant_devices; d++){
      time[d] = 0.0;
      square_root[d] = 0.0;
      avrage_timing[d] = 0.0;
      avrage_timing_cpu[d] = 0.0;
     }
    //printf("Timing the transfer of %f MB data with clEnqueueWriteBuffer \n", ant_element * sizeof(float)*toMB);
    for (int i = 0 ; i < ant_ittr;i++)
    {
      getTimeInMs(t1);

      for(int d = 0; d < ant_devices; d++){
        writeBuffer(queues[d],d_data,h_data,ant_element * sizeof(float),&events[d]); 
      }

      for(int d = 0; d < ant_devices; d++){
        queues[d].finish();
      }

      getTimeInMs(t2);

      for(int d = 0; d < ant_devices; d++){
        indivudual_timing[i][d] = executionTime(events[d]);
        //indivudual_timing[i][d] =  5; //executionTime(events[d]);
        //indivudual_timing[i][d] =  dumme[i]; //executionTime(events[d]);


        
        avrage_timing[d] += indivudual_timing[i][d];
        time[d] += indivudual_timing[i][d];
        avrage_timing_cpu[d] += ((double)(t2-t1) / 1.0e6);
      }
    }

    for(int d = 0; d < ant_devices; d++){
      avrage_timing[d] /= (double)ant_ittr;
      avrage_timing_cpu[d] /= (double)ant_ittr;
    }
    for (int it = 0; it < ant_ittr; it ++){
      for(int d = 0; d < ant_devices; d++){
        double diff = fabs(indivudual_timing[it][d] - avrage_timing[d]);
        double ratio = (diff / avrage_timing[d]);
        if (ratio > 1.0){
          //printf("individual timing %d in bw, time %e mean %e ratio %e\n",it,indivudual_timing[it][d],avrage_timing[d],ratio);
        }
       square_root[d] += (pow(diff,2.0));
      }
    }



    for(int d = 0; d < ant_devices; d++){
      time[d] =  (time[d] / ((double) ant_ittr)) - time_startup[d]; //converte from seconds to ms
      
      if (time[d] < 0.0){
        printf("negative time %e \n", time[d]);
      }
      
      square_root[d] /= ant_ittr;
      square_root[d] = sqrt(square_root[d]);

      time_full[d] = time[d];
      time_full_var[d] = square_root[d];

      time_full_cpu[d] = avrage_timing_cpu[d];
    }


  delete[] h_data;
  delete[] events;

}